Discord: discord.gg/ddjKRXPqtk Correction: Time complexity is O(nlogn + n + m) where n is size of products, and m is length of searchWord.
@masternobody18962 жыл бұрын
Bug brain time
@anon3252 жыл бұрын
It should be S*nlogn + n + m where s is avg string length.
@aishwaryaranghar33852 жыл бұрын
can you make a video one day for all the complexities.
@tomyao78842 жыл бұрын
Very nice correction
@mirceanicolaescu98042 жыл бұрын
it is actually a little worse than that because we have to account for copying over the strings into the result map at the end. so it would be something like S*nlogn + n + m * S
@uditsharma56882 жыл бұрын
Nice man , i used a binary search but two Pointer is more intuitive and easier to remember for me now. 👍
@rockstars3692 жыл бұрын
For those who are wondering the purpose of 2nd pointer(right ptr.) as it isn't obvious in the video due to the example. In the example, it appears like we could get the solution for each typed character with constant amount of work i.e check the next 3 words from the current index of first pointer(left/top) and if they match the typed character add the word to the list and then append to the result List. The efficient way to verify the next 3 words from current index of first pointer(left ptr.) is just check the current char directly instead of reverifying all the previous chars of the next 3 words are also matching the prefix typed so far of the searchWord. Too much blabbering 🙃..... In short 2nd pointer is to limit the search space and guarantee that as long as the index of 1st pointer(left ptr) is less than or equal to 2nd pointer (right ptr) we are still in valid search space and avoid reverifying all the previous chars of the next 3 words from 1st pointer. Example : sorted search list = [mobile, monitor, mousepad, muumuu, tsunami, vault...] searchWord = mouse 1) char 'm' = [mobile, monitor, mouse] 2) char 'o' = [mobile, monitor, mouse] 3) char 'u' = [mouse] -> *current search char is 'u' with prefix searched so far "mo", without a second pointer we would have to reverify "mo" is also a prefix for words mousepad, muumuu, tsunami.*
@lonen3rd8 ай бұрын
You're right. The first idea that came to mind was Trie, but the implementation was not easy.
@dianasvideos1232 жыл бұрын
Woah! This was my Amazon question last year! Thank you for this video, Neetcode! I’ve been meaning to re-attempt this! 😃
@ObtecularPk2 жыл бұрын
Did you get it right?
@dianasvideos1232 жыл бұрын
@@ObtecularPk No, I ran out of time 😅
@ramkrushnamadole8742 жыл бұрын
Did u place in Amazon
@ObtecularPk2 жыл бұрын
@@ramkrushnamadole874 what do you think? If she missed a question and ran outta time.
@dianasvideos1232 жыл бұрын
@@ramkrushnamadole874 No, but I did get to try again 6 months later, and then I failed again 😅 But the moral of the story is- it wasn’t the end of the world 🙂 After that first failure, I was still able to interview with Meta (twice), Amazon again, and then Google as well last May 🙂 Each time I interviewed, I got A LOT better, but I’m still not quite there yet 🤷🏻♀️ I think if you want to interview with FAANG/MANGA, just do it 🙂 If anything, it’ll give you an idea of where you currently stand and what you need to work on 😄🤷🏻♀️
@Mutual_Information2 жыл бұрын
Out of all the channels that try to help people transition into tech, this one has to be the most useful. Seriously these problem coding skills, as petty as they appear, as huge for getting an offer.
@coderabbit1182 жыл бұрын
Thank you very much for these helpful videos. I did Blind75 and watched your solutions for those 75 questions! I must say, the solutions help me a lot for my tech round interviews!
@zbynekjurica2 жыл бұрын
Wouldn't it be better to use binary search to move the pointers instead of just moving it by 1? Anyway, great explanation!
@zr602 жыл бұрын
binary search is more complex, because of the string slicing required in comparison.
@joelpww2 жыл бұрын
Idk if it was corrected but lexicographically and alphabetically are different. The former is alphabetically order preceded by a length comparison
@joelpww2 жыл бұрын
So this is asking for alphabetical and shortest results
@nickheyer2 жыл бұрын
Hey @NeetCode, wouldn't it be faster to use a slice on the final append to answer instead of that for j in range loop? ie: answer.append(products[l:min(3, r - l + 1)+l])
@ooow333 Жыл бұрын
result.append(products[l:r+1][:3]) also works
@hugoibanez2 жыл бұрын
I really have no clue how are we supposed to come up with this sort of answers during an interview if we never saw the problem 😅
@johnpaul43012 жыл бұрын
yep same bro
@shokhrukhabduahadov39855 ай бұрын
But question does not mention about products being sorted (or coming in order)
@adityadhikle94732 жыл бұрын
I think on your website you should list this problem under two pointers rather than binary search.
@alanprado16522 жыл бұрын
this is just to complex to get in my head :/. i always pause the video to try to understand it but i don't get when he adds a bunch of code in the same line, i feel frustrated😢
@DavidDLee Жыл бұрын
I'd use a TreeMap / std::map, which will do the l/r portion in logN time
@tanishq2766 Жыл бұрын
Yeah i solved using the same technique
@akhma102Ай бұрын
Thank you, Neet!
@oscarheerkensthijssen545411 ай бұрын
How about res.append(products[l:min(l+3, r+1)]) instead of lines 15-18
@raihanulalamhridoy47142 жыл бұрын
Thank you. The explanation was really good. Better than leetcode solution page.
@vineethsai15752 жыл бұрын
The future generations are very lucky because by that time you might have completed videos for most of the leetcode problems!
@sudhanshushekhar42224 ай бұрын
really amazing explanation....
@shrimpo64162 жыл бұрын
2 pointer solution is so neeeeeeeeeeeeet!!!
@wintersol99212 жыл бұрын
Your explenations are great.
@NeetCode2 жыл бұрын
Thanks! 🙂
@memeproductions41822 жыл бұрын
Right pointer doesn't change complexity right?i could just iterate all words with left pointer and sfill find the first match, then just pick the first 3 matches from there
@dynamic.63022 жыл бұрын
Yes, as you iterate with your left pointer and check if it matches, you also need to check with left + 1 and left + 2 if it matches with the left pointer. And you need to ensure left + 1 and left + 2 are less than len(searchWord)
@flamendless2 жыл бұрын
Question, would this algo scale for a database table (sorted always) with millions of data? hmmmmmmm
@tempestofsouls56932 жыл бұрын
Solved it using Trie + DFS. Should've realized that there was a much simpler solution using binary search or two pointer :/
@shayanshayan87412 жыл бұрын
Can I send a graph question and also a simple question that I didn't get to solve. Will you have look into that
@PunithNayak-rj3fg Жыл бұрын
Hey please mention the the time and space complexity for every question you solve
@altusszawlowski420911 ай бұрын
He did at 7:47
@EMdragonKnight6 ай бұрын
Can you do this problem as a Trie?
@austinhuang24542 жыл бұрын
For the testcase of ["havana"] "havana", r will be 5, which occurs an error that list index out of range for products[r] and products[r][i]. How do you fix this?
@austinhuang24542 жыл бұрын
my bad, the right pointer should be len(products) - 1.
@austinhuang24542 жыл бұрын
which would fix the issue of my question
@davidardo44662 жыл бұрын
hello teacher, i have two question? math is important to software engineer? Second question? can i do better math? third/Sir, I'd like to work with Google in the future. Can I?
@johnpaul43012 жыл бұрын
go out and touch grass
@neerajasanjay23757 ай бұрын
It gives a TLE now right?
@bree98957 ай бұрын
here after a year! and after 2 jobs:)
@trollbaron13292 жыл бұрын
Hi Neetcode, love your succinct and clear explanation! Would you be willing to make videos on more advanced concepts like Segment Trees and String Hashing/KMP algorithm?
@mdazharuddin46842 жыл бұрын
I believe Trie will be more practical if the word list is mutable.
@cyanimpostor69712 жыл бұрын
It's more of a concept and application I believe
@memeproductions41822 жыл бұрын
How would you implement it with trie?i get you add all words character by character. But what when you search them up?you search until the prefix but then?you'll have to explore all the children subtrees and get the first 3 lexically minor
@mdazharuddin46842 жыл бұрын
@@memeproductions4182 maybe a dfs preorder traversal
@dynamic.63022 жыл бұрын
@@memeproductions4182 In your TrieNode class, have two attributes - children and suggestions. As you insert your product to the TrieNode, also add the product in the suggestions field. Suggestions can be an array and you can sort this array whenever you insert to it. Also, ensure that you pop out the elements whenever suggestions.size is greater than 3. Sorry if you didn't understand this. Will be happy to elaborate on this
@mdazharuddin46842 жыл бұрын
@@dynamic.6302 won't that take more time to keep updating the suggestion at every insert? I tried the dfs approach, took 2887ms while the two-pointer took only 115ms
@aishwaryaranghar33852 жыл бұрын
Thank You!
@mk-19memelauncher65 Жыл бұрын
This doesnt seem scalable because you would need to sort every word first.
@vivekshaw20952 жыл бұрын
yesterday I took a test from aquasec this was my question with a bit of twist, insteaf of prefix I had suffix and instead of just one search word I had an array of multiple words
@shantanukumar40812 жыл бұрын
Masterpiece 👌👌👌
@ohhellnooooo82332 жыл бұрын
Hello, what's the app you use for doodling?
@NeetCode2 жыл бұрын
Paint3d
@ReAgent0032 жыл бұрын
@@NeetCode :D
@janailtongoncalvesdesouza41606 ай бұрын
Very clever!
@mageshyt25502 жыл бұрын
const suggestedProducts = (products, searchWord) => { let ans = []; products.sort(); for (let i = 0; i < searchWord.length; i++) { const curr_search = searchWord.slice(0, i + 1); let temp = []; for (let j = 0; j < products.length; j++) { if (products[j].startsWith(curr_search)) { if (temp.length < 3) { temp.push(products[j]); } } } ans.push(temp); } return ans; };